;I somehow thought I could impress people with this code :) SUPER SMALL!!!!

#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "By:TSW",0

hiscore:
	.dw 0

ProgStart:
	call _clrLCD
	ld a, 50
	ld (tunnelwidth), a
	ld (tunnelpos), a
	ld hl, 0
gameloop:
	ld (score), hl
	ld hl, car
	ld a, (carpos)
	ld e, a
	push hl
	ld h, $3f
	ld l, h
	rra
	add hl, hl
	rra
	add hl, hl
	rra
	ld l, a
	ld a,e
	and %00000111
	pop ix
	ld b, 7
	ld c, a
ds21lp:
	push bc
	ld d, (ix+0)
	ld a, c
	ld c, 0
	or a
	jr z, skiprotate
	ld b, a
ds21lp2:
	rr d
	rr c
	djnz ds21lp2
skiprotate:
	ld a, (hl)
	or d
	ld (hl), a
	inc hl
	ld a, (hl)
	or c
	ld (hl), a
	inc ix
	ld bc, 15
	add hl, bc
	pop bc
	djnz ds21lp
	ld b, 127
	ld hl, $ffff
	ld d, %00000001
dtloop:
	push bc
	ld a, (tunnelwidth)
	ld c, a
	ld a, (tunnelpos)
	cp b
	jr nc, backtunnel
	add a, c
	cp b
	jr c, backtunnel
	ld a, d
	cpl
	and (hl)
	ld (hl), a
	jr doneerase
backtunnel:
	ld a, d
	or (hl)
	ld (hl), a
doneerase:
	rlc d
	call c, dechl
	pop bc
	djnz dtloop
	push de
	ld de, $ffe0
	ld hl, $fff0
	ld c, 16
	ldir
	pop de
	ld hl, tunnelpos
	ld a, (tunnelaim)
	cp (hl)
	call z, changeaim
	jr c, tunnelleft
	inc (hl)
	inc (hl)
tunnelleft
	dec (hl)
finishloop:
	ld hl, $fc20				;scroll
	ld de, $fc00
	ld bc, 992
	ldir
keyloop:												;most of games processing goes here, because it doubles as a null loop
 	ld a,%1111110
	out (1),a
 	in a,(1)
	ld d, c
	rra
 	rra
 	jr nc,nextkeyl
	inc d
 	rra
 	jr nc,nextkeyl
	inc d
nextkeyl:
	djnz keyloop
	ld a, d
; keys:
; 0=left
; 1=right
	ld hl, carpos
	or a
	jr nz, nomovecarleft
	dec (hl)
nomovecarleft:
	cp 1
	jr nz, nomovecarright
	ld a, (hl)
	cp 117
	jr z, nomovecarright
	inc (hl)
nomovecarright:
	ld b, (hl)
	push bc
	call findpixel
	pop bc
	and (hl)						
	jr nz, dead
	ld a, b
	add a, 5
	ld b, a
	call findpixel
	and (hl)
	jr nz, dead
	ld hl, (score)
	inc hl
	jp gameloop
dead:
	call highscoreroutine
	ld hl, (score)
	ld de, $0600
	call drawnumber
	ld hl, (hiscore)
	ld de, $0701
	call drawnumber
	ld hl, scoretxt+1
	ld de, 0
	call drawstring
	ld hl, scoretxt
	ld de, $0001
	call drawstring
	jp _pause

scoretxt:
	.db "HScore:", 0

drawnumber:
	xor a
	ld (_CurRow), de
	jp _dispAHL
drawstring:
	ld (_CurRow), de
	jp _puts

highscoreroutine:
	ld hl, (score)
	ld de, (hiscore)
	ld a, d
	cp h
	jr c, highscoreset
	jr z, checksame
	ret 
checksame:
	ld a, e
	cp l
	ret nc
highscoreset
	ld (hiscore), hl
	push hl
	ld hl, name-1					
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _load_ram_ahl
	ld de,hiscore-$d744		;-$d744 = -$d748 (program counter) + 4 (header thingy)
	add hl,de
	pop de
	ld (hl), e
	inc hl
	ld (hl), d
	ret

changeaim:
	ld a, r
	and %00001111
	call z, make7
	ld b, a
	ld a, (hl)
	sub 8
	add a, b
	cp 90
	ret nc
	inc hl
	ld (hl), a
	ld de, gamespeed
	ld a, (de)
	dec a
	or a
	jr nz, changecounter
	inc hl
	dec (hl)
	ld a, (hl)
changecounter:
	ld (de), a
	dec hl
make7:
	ld a, 8
	ret
dechl:
	dec hl
	ret

FindPixel:
	ld h,63
	ld l, 28
	ld a,b
	rra
	add hl,hl
	rra
	add hl,hl
	rra
	or l
	ld l,a
	ld a,b
	and %00000111
	ld bc,FP_Bits
	add a,c
	ld c,a
	adc a,b
	sub c
	ld b,a
	ld a,(bc)
	ret
FP_Bits:
	.db %10000000
	.db %01000000
	.db %00100000
	.db %00010000
	.db %00001000
	.db %00000100
	.db %00000010
	.db %00000001

Car:
	.db %00111000
	.db %01111100
	.db %01000100
	.db %00111000
	.db %00111000
	.db %00010000
	.db %00111000

Carpos:	.db 60
Tunnelpos:	.db 48
tunnelaim:	.db 47
tunnelwidth: .db 40
score:	.dw 0
gamespeed:	.db 20

name:
	.db 7, "Skydive"

.end
